Katello 4.2 to 4.3 upgrade doesn't trigger apipie:cache:index, breaking some new hammer

commands
Priority: Normal   

Assignee: Ewoud Kohl van Wijngaarden   

Category: Foreman modules   

Target version: 3.1.1   

Difficulty:  Fixed in Releases: 3.1.1, 3.2.0

Triaged: Yes Found in Releases: 3.1.0, 3.2.0
Pull request: https://github.com/theforeman/puppet-for

eman/pull/1010

  

Description

In Katello 4.2 hammer gained new parameters to "capsule content synchronize": --content-view and --repository.

However, for that to work, hammer needs a fresh apidoc, and it seems that wasn't generated.

From the upgrade log:

# grep -i 'Foreman::Rake.apipie:cache' /var/log/foreman-installer/katello.log

2021-12-16 10:45:57 [DEBUG ] [configure] Adding relationship from Foreman::Rake[db:seed] to Forema

n::Rake[apipie:cache:index] with 'notify'

2021-12-16 10:45:57 [DEBUG ] [configure] Adding relationship from Package[tfm-rubygem-foreman-task

s] to Foreman::Rake[apipie:cache:index] with 'notify'

2021-12-16 10:45:57 [DEBUG ] [configure] Adding relationship from Package[tfm-rubygem-katello] to 

Foreman::Rake[apipie:cache:index] with 'notify'

2021-12-16 10:45:57 [DEBUG ] [configure] Adding relationship from Package[tfm-rubygem-foreman_pupp

et] to Foreman::Rake[apipie:cache:index] with 'notify'

2021-12-16 10:45:57 [DEBUG ] [configure] Adding relationship from Package[tfm-rubygem-foreman_remo

te_execution] to Foreman::Rake[apipie:cache:index] with 'notify'

2021-12-16 10:45:58 [DEBUG ] [configure] /Stage[main]/Foreman::Database/Foreman::Rake[db:seed]/not

ify: notify to Foreman::Rake[apipie:cache:index]

2021-12-16 10:45:58 [DEBUG ] [configure] /Stage[main]/Foreman::Plugin::Tasks/Foreman::Plugin[tasks

]/Package[tfm-rubygem-foreman-tasks]/notify: notify to Foreman::Rake[apipie:cache:index]

2021-12-16 10:45:58 [DEBUG ] [configure] /Stage[main]/Katello::Application/Foreman::Plugin[katello

]/Package[tfm-rubygem-katello]/notify: notify to Foreman::Rake[apipie:cache:index]

2021-12-16 10:45:58 [DEBUG ] [configure] /Stage[main]/Foreman::Plugin::Puppet/Foreman::Plugin[pupp

et]/Package[tfm-rubygem-foreman_puppet]/notify: notify to Foreman::Rake[apipie:cache:index]

2021-12-16 10:45:58 [DEBUG ] [configure] /Stage[main]/Foreman::Plugin::Remote_execution/Foreman::P

lugin[remote_execution]/Package[tfm-rubygem-foreman_remote_execution]/notify: notify to Foreman::R

ake[apipie:cache:index]

2021-12-16 10:45:58 [DEBUG ] [configure] /Stage[main]/Foreman/Foreman::Rake[apipie:cache:index]/Ex

ec[foreman-rake-apipie:cache:index]: Adding autorequire relationship with User[foreman]

2021-12-16 10:46:44 [DEBUG ] [configure] Foreman::Rake[apipie:cache:index]: Starting to evaluate t

he resource (1274 of 1894)

2021-12-16 10:46:44 [DEBUG ] [configure] Foreman::Rake[apipie:cache:index]: Evaluated in 0.00 seco

nds

2021-12-16 10:46:44 [DEBUG ] [configure] /Stage[main]/Foreman/Foreman::Rake[apipie:cache:index]/Ex

ec[foreman-rake-apipie:cache:index]: Starting to evaluate the resource (1284 of 1894)

2021-12-16 10:46:44 [DEBUG ] [configure] /Stage[main]/Foreman/Foreman::Rake[apipie:cache:index]/Ex

ec[foreman-rake-apipie:cache:index]: '/usr/sbin/foreman-rake apipie:cache:index' won't be executed

 because of failed check 'refreshonly'

2021-12-16 10:46:44 [DEBUG ] [configure] /Stage[main]/Foreman/Foreman::Rake[apipie:cache:index]/Ex

ec[foreman-rake-apipie:cache:index]: Evaluated in 0.00 seconds

2021-12-16 10:46:44 [DEBUG ] [configure] Foreman::Rake[apipie:cache:index]: Starting to evaluate t

he resource (1285 of 1894)
2021-12-16 10:46:44 [DEBUG ] [configure] Foreman::Rake[apipie:cache:index]: Evaluated in 0.00 seco

nds

 I would expect to see the following line:

[DEBUG ] [configure] Executing with uid=foreman: '/usr/sbin/foreman-rake apipie:cache:index'

Environment:

CentOS 7

puppet-agent-6.25.1-1.el7.x86_64

Steps to reproduce:

Install Katello 4.2

yum localinstall https://yum.theforeman.org/releases/3.1/el7/x86_64/foreman-release.rpm

https://yum.theforeman.org/katello/4.3/katello/el7/x86_64/katello-repos-latest.rpm

foreman-maintain service stop

yum upgrade

foreman-installer

hammer --reload-cache capsule content synchronize --help → no --content-view

foreman-rake apipie:cache:index

hammer --reload-cache capsule content synchronize --help → --content-view now present

Associated revisions

Revision a293e008 - 12/16/2021 04:20 PM - Ewoud Kohl van Wijngaarden

Fixes #34161 - Run apipie:cache:index after db:migrate

With Puppet you can write:

Class['A'] ~> Class['B'] ~> Class['C']

 This implies Class['A'] ~> Class['C'] and rspec-puppet actually will

tell you that chaining is there, but it doesn't actually happen. This

was reported in https://github.com/rodjek/rspec-puppet/pull/821.

In this particular case it means that if DB seeding doesn't happen then

the apipie caches indexes aren't refreshed. By chaining it to db:migrate

there's a much bigger chance it actually happens.

Normally apipie:cache:index needs to run after a package is updated so

ideally this would actually be done in packaging, but this is the

workaround we've been using for a long time.

History

#1 - 12/16/2021 11:32 AM - Evgeni Golov

- Subject changed from Katello 4.2 to 4.2 upgrade doesn't trigger apipie:cache:index, breaking some new hammer commands to Katello 4.2 to 4.3

upgrade doesn't trigger apipie:cache:index, breaking some new hammer commands

#2 - 12/16/2021 03:49 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/puppet-foreman/pull/1010 added

#3 - 12/17/2021 10:04 AM - The Foreman Bot

- Fixed in Releases 3.2.0 added

#4 - 12/17/2021 11:01 AM - Ewoud Kohl van Wijngaarden

- Status changed from Ready For Testing to Closed

Applied in changeset puppet-foreman|a293e0084d3c2d62c12ccc6a13338b5db01fe8cf.

#5 - 01/14/2022 05:15 PM - Ewoud Kohl van Wijngaarden
https://github.com/rodjek/rspec-puppet/pull/821
https://projects.theforeman.org/projects/puppet-foreman/repository/puppet-foreman/revisions/a293e0084d3c2d62c12ccc6a13338b5db01fe8cf


- Category set to Foreman modules

- Target version set to 3.1.1

This is affecting Foreman 3.1 and blocking Katello 4.3's pipelines. It should be cherry picked.

#6 - 01/26/2022 01:04 PM - Ewoud Kohl van Wijngaarden

- Triaged changed from No to Yes

- Fixed in Releases 3.1.1 added
